#include <math.h>
#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>

#define FNAME_SIZE2 160
#define NUM_MD_DIRS2 10000

#define ELEM_SWAP_UINT8(a,b) { register unsigned char t=(a);(a)=(b);(b)=t; }
#define ELEM_SWAP_INT(a,b) { register int t=(a);(a)=(b);(b)=t; }

double std(unsigned char nums[], double mean_value, int n);
double average(unsigned char nums[], int n);
unsigned char median_uint8(unsigned char arr[], int n);
int median_int(int arr[], int n);
void histogram_eq(unsigned char *in, int n);
void stretch(unsigned char *in, int n, float p_low, float p_up);
int find_md_folder_num(char *basedir);
int file_exists(char *fname);
unsigned char limit(double val);
void calc_ts_histogram(int *ts, unsigned char *ref, unsigned char *img, int npix);
unsigned char histogram_compare(int *hist, int *ref, unsigned char md_min_tl);
void save_histogram(char *fname, int *hist);
